// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;
import SceneComponent from "../../scene/duiduipeng";

@ccclass
export default class card extends cc.Component {
    @property(cc.Node)
    iconN: cc.Node = null;
    @property(cc.Node)
    backN: cc.Node = null;
    @property(cc.Label)
    wordLabel: cc.Label = null;
    mainControl:SceneComponent=null;
    data=null

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    start () {
        this.node.on("click",()=>{
            this.doFlip()
 
         })

    }
    initData(data,mainControl){
        this.data=data;
        this.mainControl=mainControl
        this.node.off("click")
        this.node.on("click",()=>{
           this.doFlip()

        })
        this.updateBtnAble(false);
        if(this.data.type=="img"){
            this.iconN.active=true;
            this.iconN.scaleX=1
            this.mainControl.getSprForNodeByUrl(this.data.image,this.iconN,()=>{
                if(this.iconN.width/this.iconN.height>200/240){
                    this.iconN.scale=200/this.iconN.width
                }else{
                    this.iconN.scale=240/this.iconN.height
                }
            });
            this.wordLabel.string=""
        }else{
            this.wordLabel.node.scaleX=1
            this.wordLabel.string=this.data.text
        }
     
    }
    updateBtnAble(interactable){
        this.node.getComponent(cc.Button).interactable=interactable;
    }
    doFlip(cb=null){
        this.node.stopAllActions();
        if(this.node.scaleX>0){
            cc.tween(this.node)
            .to(0.25,{scaleX:0})
            .call(()=>{
                this.iconN.scaleX=-this.iconN.scaleX
                this.wordLabel.node.scaleX=-1
                this.backN.active=false
            })
            .to(0.25,{scaleX:-1})
            .start();
        }else{
            cc.tween(this.node)
            .to(0.25,{scaleX:0})
            .call(()=>{
                this.iconN.scaleX=-this.iconN.scaleX
                this.wordLabel.node.scaleX=1
                this.backN.active=true
            })
            .to(0.25,{scaleX:1})
            .start();
        }


    }


    // update (dt) {}
}
